//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <list>
#include <algorithm>
#include <conio.h> //  getch()
#include <cstdlib> // abs{)

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

//  ,      
bool isPrime (int number)
{
  //    
  number = abs(number);

  // 0  1     
  if (number == 0 || number == 1) { 
    return false;
  }

  //  ,      
  int divisor;
  for (divisor = number/2; number%divisor != 0; --divisor) { ;
  }
  //      ,  1. 
  //    . 
  return divisor == 1;
}

int main(int argc, char* argv[])
{
  list<int> coll;
  //      24  30 
  for (int i=24; i<=30; ++i) { 
    coll.push_back(i);
  }
  //    
  list<int>::iterator pos;
  pos = find_if (coll.begin(), coll.end(), // 
    isPrime); // 
  if (pos != coll.end()) {
    //   
    cout << *pos << ToRus("    ") << endl;
  } else {
    //    
    cout << ToRus("  ") << endl;
  }
  cout << endl;

  getch();
  return 0;
}
//---------------------------------------------------------------------------
